package io.gitlab.jfronny.scripts

import org.gradle.api.Project
import org.gradle.api.provider.Property
import org.jetbrains.annotations.ApiStatus.Internal

interface JfModuleExtension {
    val devOnly: Property<Boolean>

    @Internal
    fun check(proj: Project) {
        devOnly.finalizeValue()
        require(proj != proj.rootProject || !devOnly.getOrElse(false)) { "Root project may not be devOnly" }
    }
}